Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmicro.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmicro.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmicro.F90	(revision 2823)
@@ -6,4 +6,5 @@
    !! History :   1.0  !  2004     (O. Aumont) Original code
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
+   !!             3.4  !  2011-06  (O. Aumont, C. Ethe) Quota model for iron
    !!----------------------------------------------------------------------
 #if defined key_pisces
@@ -14,12 +15,11 @@
    !!   p4z_micro_init  :   Initialize and read the appropriate namelist
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE trc         ! 
-   USE sms_pisces      ! 
-   USE prtctl_trc
-   USE p4zint
-   USE p4zsink
-   USE iom
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE p4zint          !  interpolation and computation of various fields
+   USE p4zprod         !  production
+   USE prtctl_trc      !  print control for debugging
 
    IMPLICIT NONE
@@ -30,15 +30,16 @@
 
    !! * Shared module variables
-   REAL(wp), PUBLIC ::   &
-      xpref2c = 0.0_wp       ,  &  !:
-      xpref2p = 0.5_wp       ,  &  !:
-      xpref2d = 0.5_wp       ,  &  !:
-      resrat  = 0.03_wp      ,  &  !:
-      mzrat   = 0.0_wp       ,  &  !:
-      grazrat = 4.0_wp       ,  &  !:
-      xkgraz  = 20E-6_wp     ,  &  !:
-      unass   = 0.3_wp       ,  &  !:
-      sigma1  = 0.6_wp       ,  &  !:
-      epsher  = 0.33_wp
+   REAL(wp), PUBLIC ::  part    = 0.5_wp     !: part of calcite not dissolved in microzoo guts
+   REAL(wp), PUBLIC ::  xpref2c = 0.2_wp     !: microzoo preference for POC 
+   REAL(wp), PUBLIC ::  xpref2p = 1.0_wp     !: microzoo preference for nanophyto
+   REAL(wp), PUBLIC ::  xpref2d = 0.6_wp     !: microzoo preference for diatoms
+   REAL(wp), PUBLIC ::  xthresh = 2E-7_wp    !: feeding threshold for microzooplankton 
+   REAL(wp), PUBLIC ::  resrat  = 0.03_wp    !: exsudation rate of microzooplankton
+   REAL(wp), PUBLIC ::  mzrat   = 0.0_wp     !: microzooplankton mortality rate 
+   REAL(wp), PUBLIC ::  grazrat = 3.0_wp     !: maximal microzoo grazing rate
+   REAL(wp), PUBLIC ::  xkgraz  = 20E-6_wp   !: non assimilated fraction of P by microzoo 
+   REAL(wp), PUBLIC ::  unass   = 0.3_wp     !: Efficicency of microzoo growth 
+   REAL(wp), PUBLIC ::  sigma1  = 0.6_wp     !: Fraction of microzoo excretion as DOM 
+   REAL(wp), PUBLIC ::  epsher  = 0.3_wp     !: half sturation constant for grazing 1 
 
 
@@ -63,9 +64,10 @@
       INTEGER, INTENT(in) ::   kt ! ocean time step
       INTEGER  :: ji, jj, jk
-      REAL(wp) :: zcompadi, zcompadi2, zcompaz , zcompaph, zcompapoc
-      REAL(wp) :: zgraze  , zdenom  , zdenom2, zstep
-      REAL(wp) :: zfact   , zinano , zidiat, zipoc
+      REAL(wp) :: zcompadi, zcompaz , zcompaph, zcompapoc
+      REAL(wp) :: zgraze  , zdenom, zncratio
+      REAL(wp) :: zfact   , zstep, zfood, zfoodlim
+      REAL(wp) :: zepshert, zepsherv, zgrarsig, zgraztot, zgraztotf
       REAL(wp) :: zgrarem, zgrafer, zgrapoc, zprcaca, zmortz
-      REAL(wp) :: zrespz, ztortz
+      REAL(wp) :: zrespz, ztortz, zgrasrat
       REAL(wp) :: zgrazp, zgrazm, zgrazsd
       REAL(wp) :: zgrazmf, zgrazsf, zgrazpf
@@ -74,15 +76,12 @@
       !!---------------------------------------------------------------------
 
-
 #if defined key_diatrc
       grazing(:,:,:) = 0.  !: Initialisation of  grazing
 #endif
-
-      zstep = rfact2 / rday      ! Time step duration for biology
 
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zcompaz = MAX( ( trn(ji,jj,jk,jpzoo) - 1.e-9 ), 0.e0 )
+               zcompaz = MAX( ( trn(ji,jj,jk,jpzoo) - 1.e-8 ), 0.e0 )
 # if defined key_degrad
                zstep   = xstep * facvol(ji,jj,jk)
@@ -90,10 +89,10 @@
                zstep   = xstep
 # endif
-               zfact   = zstep * tgfunc(ji,jj,jk) * zcompaz
+               zfact   = zstep * tgfunc2(ji,jj,jk) * zcompaz
 
                !  Respiration rates of both zooplankton
                !  -------------------------------------
-               zrespz = resrat * zfact  * ( 1.+ 3.* nitrfac(ji,jj,jk) )     &
-                  &            * trn(ji,jj,jk,jpzoo) / ( xkmort + trn(ji,jj,jk,jpzoo) )
+               zrespz = resrat * zfact * trn(ji,jj,jk,jpzoo) / ( 2. * xkmort + trn(ji,jj,jk,jpzoo) )  &
+                  &   + resrat * zfact * 3. * nitrfac(ji,jj,jk)
 
                !  Zooplankton mortality. A square function has been selected with
@@ -102,63 +101,59 @@
                ztortz = mzrat * 1.e6 * zfact * trn(ji,jj,jk,jpzoo)
 
-               zcompadi  = MAX( ( trn(ji,jj,jk,jpdia) - 1.e-8 ), 0.e0 )
-               zcompadi2 = MIN( zcompadi, 5.e-7 )
-               zcompaph  = MAX( ( trn(ji,jj,jk,jpphy) - 2.e-7 ), 0.e0 )
+               zcompadi  = MIN( MAX( ( trn(ji,jj,jk,jpdia) - 1.e-8 ), 0.e0 ), 5.e-7 )
+               zcompaph  = MAX( ( trn(ji,jj,jk,jpphy) - 1.e-8 ), 0.e0 )
                zcompapoc = MAX( ( trn(ji,jj,jk,jppoc) - 1.e-8 ), 0.e0 )
                
                !     Microzooplankton grazing
                !     ------------------------
-               zdenom2 = 1./ ( xpref2p * zcompaph + xpref2c * zcompapoc + xpref2d * zcompadi2 + rtrn )
-
-               zgraze = grazrat * zstep * tgfunc(ji,jj,jk) * trn(ji,jj,jk,jpzoo)
-
-               zinano = xpref2p * zcompaph  * zdenom2
-               zipoc  = xpref2c * zcompapoc * zdenom2
-               zidiat = xpref2d * zcompadi2 * zdenom2
-
-               zdenom = 1./ ( xkgraz + zinano * zcompaph + zipoc * zcompapoc + zidiat * zcompadi2 )
-
-               zgrazp  = zgraze * zinano * zcompaph * zdenom
-               zgrazm  = zgraze * zipoc  * zcompapoc * zdenom
-               zgrazsd = zgraze * zidiat * zcompadi2 * zdenom
-
-               zgrazpf = zgrazp  * trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy) + rtrn)
-               zgrazmf = zgrazm  * trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)
-               zgrazsf = zgrazsd * trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)
+               zfood     = xpref2p * zcompaph + xpref2c * zcompapoc + xpref2d * zcompadi + rtrn
+               zfoodlim  = MAX( 0. , zfood - xthresh )
+               zdenom    = zfoodlim / zfood / ( xkgraz + zfoodlim )
+               zgraze    = grazrat * zstep * tgfunc2(ji,jj,jk) * trn(ji,jj,jk,jpzoo) * zdenom
+               zgrazp    = zgraze  * xpref2p * zcompaph 
+               zgrazm    = zgraze  * xpref2c * zcompapoc 
+               zgrazsd   = zgraze  * xpref2d * zcompadi 
+
+               zgrazpf   = zgrazp  * trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy) + rtrn)
+               zgrazmf   = zgrazm  * trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)
+               zgrazsf   = zgrazsd * trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)
+               !
+               zgraztot  = zgrazp  + zgrazm  + zgrazsd 
+               zgraztotf = zgrazpf + zgrazsf + zgrazmf 
 #if defined key_diatrc
                ! Grazing by microzooplankton
-               grazing(ji,jj,jk) = grazing(ji,jj,jk) + zgrazp + zgrazm + zgrazsd 
+               grazing(ji,jj,jk) = grazing(ji,jj,jk) + zgraztot
 #endif
 
                !    Various remineralization and excretion terms
                !    --------------------------------------------
-               zgrarem = ( zgrazp + zgrazm + zgrazsd ) * ( 1.- epsher - unass )
-               zgrafer = ( zgrazpf + zgrazsf + zgrazmf ) * ( 1.- epsher - unass ) &
-                  &      + epsher * ( zgrazm  * MAX((trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc)+ rtrn)-ferat3),0.e0) & 
-                  &                 + zgrazp  * MAX((trn(ji,jj,jk,jpnfe) / (trn(ji,jj,jk,jpphy)+ rtrn)-ferat3),0.e0) &
-                  &                 + zgrazsd * MAX((trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia)+ rtrn)-ferat3),0.e0 )  )
-
-               zgrapoc = (  zgrazp + zgrazm + zgrazsd ) 
+               zgrasrat  = zgraztotf / ( zgraztot + rtrn )
+               zncratio  = ( xpref2p * zcompaph * quotan(ji,jj,jk) &
+                  &        + xpref2d * zcompadi * quotad(ji,jj,jk) + xpref2c * zcompapoc ) / zfood
+               zepshert  = epsher * MIN( 1., zncratio )
+               zepsherv  = zepshert * MIN( 1., zgrasrat / ferat3 )
+               zgrafer   = zgraztot * MAX( 0. , ( 1. - unass ) * zgrasrat - ferat3 * zepshert ) 
+               zgrarem   = zgraztot * ( 1. - zepsherv - unass )
+               zgrapoc   = zgraztot * unass
 
                !  Update of the TRA arrays
                !  ------------------------
-
-               tra(ji,jj,jk,jppo4) = tra(ji,jj,jk,jppo4) + zgrarem * sigma1
-               tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) + zgrarem * sigma1
-               tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zgrarem * (1.-sigma1)
-               tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) - o2ut * zgrarem * sigma1
+               zgrarsig  = zgrarem * sigma1
+               tra(ji,jj,jk,jppo4) = tra(ji,jj,jk,jppo4) + zgrarsig
+               tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) + zgrarsig
+               tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zgrarem - zgrarsig
+               tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) - o2ut * zgrarsig
                tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + zgrafer
-               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zgrapoc * unass
-               tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) + zgrarem * sigma1
+               tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zgrapoc
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + zgraztotf * unass
+               tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) + zgrarsig
+               tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) + rno3 * zgrarsig
 #if defined key_kriest
-               tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) + zgrapoc * unass * xkr_ddiat
-#endif
-
-               !
+               tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) + zgrapoc * xkr_ddiat
+#endif
                !   Update the arrays TRA which contain the biological sources and sinks
                !   --------------------------------------------------------------------
-
                zmortz = ztortz + zrespz
-               tra(ji,jj,jk,jpzoo) = tra(ji,jj,jk,jpzoo) - zmortz + epsher * zgrapoc 
+               tra(ji,jj,jk,jpzoo) = tra(ji,jj,jk,jpzoo) - zmortz + zepsherv * zgraztot 
                tra(ji,jj,jk,jpphy) = tra(ji,jj,jk,jpphy) - zgrazp
                tra(ji,jj,jk,jpdia) = tra(ji,jj,jk,jpdia) - zgrazsd
@@ -170,7 +165,8 @@
                tra(ji,jj,jk,jpdfe) = tra(ji,jj,jk,jpdfe) - zgrazsf
                tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) + zmortz - zgrazm
-               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + ferat3 * zmortz + unass * ( zgrazpf + zgrazsf ) - (1.-unass) * zgrazmf
-               zprcaca = xfracal(ji,jj,jk) * unass * zgrazp
+               tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + ferat3 * zmortz - zgrazmf
+               zprcaca = xfracal(ji,jj,jk) * zgrazp
 #if defined key_diatrc
+               ! calcite production
                prodcal(ji,jj,jk) = prodcal(ji,jj,jk) + zprcaca  ! prodcal=prodcal(nanophy)+prodcal(microzoo)+prodcal(mesozoo)
 #endif
@@ -209,9 +205,9 @@
       !!----------------------------------------------------------------------
 
-      NAMELIST/nampiszoo/ grazrat,resrat,mzrat,xpref2c, xpref2p, &
-         &             xpref2d, xkgraz, epsher, sigma1, unass
-
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampiszoo )
+      NAMELIST/nampiszoo/ part, grazrat, resrat, mzrat, xpref2c, xpref2p, &
+         &                xpref2d, xthresh, xkgraz, epsher, sigma1, unass
+
+      REWIND( numnatp )                     ! read numnat
+      READ  ( numnatp, nampiszoo )
 
       IF(lwp) THEN                         ! control print
@@ -219,14 +215,16 @@
          WRITE(numout,*) ' Namelist parameters for microzooplankton, nampiszoo'
          WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
-         WRITE(numout,*) '    zoo preference for POC                    xpref2c    =', xpref2c
-         WRITE(numout,*) '    zoo preference for nano                   xpref2p    =', xpref2p
-         WRITE(numout,*) '    zoo preference for diatoms                xpref2d    =', xpref2d
-         WRITE(numout,*) '    exsudation rate of microzooplankton       resrat    =', resrat
-         WRITE(numout,*) '    microzooplankton mortality rate           mzrat     =', mzrat
-         WRITE(numout,*) '    maximal microzoo grazing rate             grazrat   =', grazrat
-         WRITE(numout,*) '    non assimilated fraction of P by microzoo unass     =', unass
-         WRITE(numout,*) '    Efficicency of microzoo growth            epsher    =', epsher
-         WRITE(numout,*) '    Fraction of microzoo excretion as DOM     sigma1    =', sigma1
-         WRITE(numout,*) '    half sturation constant for grazing 1     xkgraz    =', xkgraz
+         WRITE(numout,*) '    part of calcite not dissolved in microzoo guts  part     =', part
+         WRITE(numout,*) '    microzoo preference for POC                     xpref2c  =', xpref2c
+         WRITE(numout,*) '    microzoo preference for nano                    xpref2p  =', xpref2p
+         WRITE(numout,*) '    microzoo preference for diatoms                 xpref2d  =', xpref2d
+         WRITE(numout,*) '    feeding threshold for microzooplankton          xthresh  =', xthresh
+         WRITE(numout,*) '    exsudation rate of microzooplankton             resrat   =', resrat
+         WRITE(numout,*) '    microzooplankton mortality rate                 mzrat    =', mzrat
+         WRITE(numout,*) '    maximal microzoo grazing rate                   grazrat  =', grazrat
+         WRITE(numout,*) '    non assimilated fraction of P by microzoo       unass    =', unass
+         WRITE(numout,*) '    Efficicency of microzoo growth                  epsher   =', epsher
+         WRITE(numout,*) '    Fraction of microzoo excretion as DOM           sigma1   =', sigma1
+         WRITE(numout,*) '    half sturation constant for grazing 1           xkgraz   =', xkgraz
       ENDIF
 
Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmort.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmort.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmort.F90	(revision 2823)
@@ -14,10 +14,9 @@
    !!   p4z_mort_init  :   Initialize the mortality params for phytoplankton
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE trc         ! 
-   USE sms_pisces      ! 
-   USE p4zsink
-   USE prtctl_trc
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE prtctl_trc      !  print control for debugging
 
    IMPLICIT NONE
@@ -29,10 +28,9 @@
 
    !! * Shared module variables
-   REAL(wp), PUBLIC ::   &
-     wchl   = 0.001_wp    ,  &  !:
-     wchld  = 0.02_wp     ,  &  !:
-     mprat  = 0.01_wp     ,  &  !:
-     mprat2 = 0.01_wp     ,  &  !:
-     mpratm = 0.01_wp           !:
+   REAL(wp), PUBLIC :: wchl   = 0.001_wp  !:
+   REAL(wp), PUBLIC :: wchld  = 0.02_wp   !:
+   REAL(wp), PUBLIC :: mprat  = 0.01_wp   !:
+   REAL(wp), PUBLIC :: mprat2 = 0.01_wp   !:
+   REAL(wp), PUBLIC :: mpratm = 0.01_wp   !:
 
 
@@ -81,5 +79,4 @@
       !!---------------------------------------------------------------------
 
-
 #if defined key_diatrc
      prodcal(:,:,:) = 0.  !: Initialisation of calcite production variable
@@ -91,5 +88,4 @@
 
                zcompaph = MAX( ( trn(ji,jj,jk,jpphy) - 1e-8 ), 0.e0 )
-
 # if defined key_degrad
                zstep =  xstep * facvol(ji,jj,jk)  
@@ -117,7 +113,9 @@
                tra(ji,jj,jk,jpnfe) = tra(ji,jj,jk,jpnfe) - zmortp * zfactfe
                zprcaca = xfracal(ji,jj,jk) * zmortp
+               !
 #if defined key_diatrc
                prodcal(ji,jj,jk) = prodcal(ji,jj,jk) + zprcaca  ! prodcal=prodcal(nanophy)+prodcal(microzoo)+prodcal(mesozoo)
 #endif
+               !
                zfracal = 0.5 * xfracal(ji,jj,jk)
                tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) - zprcaca
@@ -243,6 +241,6 @@
       NAMELIST/nampismort/ wchl, wchld, mprat, mprat2, mpratm
 
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampismort )
+      REWIND( numnatp )                     ! read numnat
+      READ  ( numnatp, nampismort )
 
       IF(lwp) THEN                         ! control print
Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90	(revision 2823)
@@ -7,4 +7,5 @@
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
    !!             3.2  !  2009-04  (C. Ethe, G. Madec)  optimisation
+   !!             3.4  !  2011-06  (O. Aumont, C. Ethe) Improve light availability of nano & diat
    !!----------------------------------------------------------------------
 #if defined  key_pisces
@@ -17,5 +18,5 @@
    USE oce_trc        ! tracer-ocean share variables
    USE sms_pisces     ! Source Minus Sink of PISCES
-   USE iom
+   USE iom            ! I/O manager
 
    IMPLICIT NONE
@@ -53,8 +54,9 @@
       !!---------------------------------------------------------------------
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY:   zdepmoy => wrk_2d_1 , zetmp => wrk_2d_2
-      USE wrk_nemo, ONLY:   zekg    => wrk_3d_2 , zekr  => wrk_3d_3 , zekb => wrk_3d_4
-      USE wrk_nemo, ONLY:   ze0     => wrk_3d_5 , ze1   => wrk_3d_6
-      USE wrk_nemo, ONLY:   ze2     => wrk_3d_7 , ze3   => wrk_3d_8
+      USE wrk_nemo, ONLY:   zdepmoy => wrk_2d_1 , zetmp  => wrk_2d_2
+      USE wrk_nemo, ONLY:   zetmp1  => wrk_2d_3 , zetmp2 => wrk_2d_4
+      USE wrk_nemo, ONLY:   zekg    => wrk_3d_2 , zekr   => wrk_3d_3 , zekb => wrk_3d_4
+      USE wrk_nemo, ONLY:   ze0     => wrk_3d_5 , ze1    => wrk_3d_6
+      USE wrk_nemo, ONLY:   ze2     => wrk_3d_7 , ze3    => wrk_3d_8
       !
       INTEGER, INTENT(in) ::   kt, jnt   ! ocean time step
@@ -63,8 +65,8 @@
       INTEGER  ::   irgb
       REAL(wp) ::   zchl, zxsi0r
-      REAL(wp) ::   zc0 , zc1 , zc2, zc3
+      REAL(wp) ::   zc0 , zc1 , zc2, zc3, z1_dep
       !!---------------------------------------------------------------------
 
-      IF(  wrk_in_use(2, 1,2)   .OR.   wrk_in_use(3, 2,3,4,5,6,7,8)   ) THEN
+      IF(  wrk_in_use(2, 1,2,3,4)   .OR.   wrk_in_use(3, 2,3,4,5,6,7,8)   ) THEN
          CALL ctl_stop('p4z_opt: requested workspace arrays unavailable')   ;   RETURN
       ENDIF
@@ -83,5 +85,5 @@
             DO ji = 1, jpi
                zchl = ( trn(ji,jj,jk,jpnch) + trn(ji,jj,jk,jpdch) + rtrn ) * 1.e6
-               zchl = MIN(  10. , MAX( 0.03, zchl )  )
+               zchl = MIN(  10. , MAX( 0.05, zchl )  )
                irgb = NINT( 41 + 20.* LOG10( zchl ) + rtrn )
                !                                                         
@@ -92,8 +94,4 @@
          END DO
       END DO
-
-!!gm  Potential BUG  must discuss with Olivier about this implementation....
-!!gm           the questions are : - PAR at T-point or mean PAR over T-level....
-!!gm                               - shallow water: no penetration of light through the bottom....
 
 
@@ -145,5 +143,5 @@
          etot3(:,:,1) =          qsr(:,:) * tmask(:,:,1)
          !
-         DO jk = 2, nksrp+1
+         DO jk = 2, nksrp + 1
 !CDIR NOVERRCHK
             DO jj = 1, jpj
@@ -188,5 +186,6 @@
       zdepmoy(:,:)   = 0.e0                    !  -------------------------------
       zetmp  (:,:)   = 0.e0
-      emoy   (:,:,:) = 0.e0
+      zetmp1 (:,:)   = 0.e0
+      zetmp2 (:,:)   = 0.e0
 
       DO jk = 1, nksrp
@@ -196,5 +195,7 @@
             DO ji = 1, jpi
                IF( fsdepw(ji,jj,jk+1) <= hmld(ji,jj) ) THEN
-                  zetmp  (ji,jj) = zetmp  (ji,jj) + etot(ji,jj,jk) * fse3t(ji,jj,jk)
+                  zetmp  (ji,jj) = zetmp  (ji,jj) + etot (ji,jj,jk) * fse3t(ji,jj,jk)
+                  zetmp1 (ji,jj) = zetmp1 (ji,jj) + enano(ji,jj,jk) * fse3t(ji,jj,jk)
+                  zetmp2 (ji,jj) = zetmp2 (ji,jj) + ediat(ji,jj,jk) * fse3t(ji,jj,jk)
                   zdepmoy(ji,jj) = zdepmoy(ji,jj) + fse3t(ji,jj,jk)
                ENDIF
@@ -210,5 +211,10 @@
 !CDIR NOVERRCHK
             DO ji = 1, jpi
-               IF( fsdepw(ji,jj,jk+1) <= hmld(ji,jj) )   emoy(ji,jj,jk) = zetmp(ji,jj) / ( zdepmoy(ji,jj) + rtrn )
+               IF( fsdepw(ji,jj,jk+1) <= hmld(ji,jj) ) THEN
+                  z1_dep = 1. / ( zdepmoy(ji,jj) + rtrn )
+                  emoy (ji,jj,jk) = zetmp (ji,jj) * z1_dep
+                  enano(ji,jj,jk) = zetmp1(ji,jj) * z1_dep
+                  ediat(ji,jj,jk) = zetmp2(ji,jj) * z1_dep
+               ENDIF
             END DO
          END DO
@@ -218,9 +224,9 @@
 # if ! defined key_iomput
       ! save for outputs
-      trc2d(:,:,  jp_pcs0_2d + 10) = heup(:,:  ) * tmask(:,:,1)  
+      trc2d(:,:,  jp_pcs0_2d + 10) = heup(:,:  ) * tmask(:,:,1)
       trc3d(:,:,:,jp_pcs0_3d + 3)  = etot(:,:,:) * tmask(:,:,:)
 # else
       ! write diagnostics 
-      IF( jnt == nrdttrc ) then 
+      IF( jnt == nrdttrc ) then
          CALL iom_put( "Heup", heup(:,:  ) * tmask(:,:,1) )  ! euphotic layer deptht
          CALL iom_put( "PAR" , etot(:,:,:) * tmask(:,:,:) )  ! Photosynthetically Available Radiation
@@ -229,6 +235,6 @@
 #endif
       !
-      IF(  wrk_not_released(2, 1,2)           .OR.   &
-           wrk_not_released(3, 2,3,4,5,6,7,8)   )   CALL ctl_stop('p4z_opt: failed to release workspace arrays')
+      IF( wrk_not_released(2, 1,2,3,4)           .OR.   &
+          wrk_not_released(3, 2,3,4,5,6,7,8)   )   CALL ctl_stop('p4z_opt: failed to release workspace arrays')
       !
    END SUBROUTINE p4z_opt
